// Fill out your copyright notice in the Description page of Project Settings.

#include "Blog_MyAsset.h"
#include "MyAsset/AssetTypeActions_MyAsset.h"

class FBlog_MyAsset : public FDefaultGameModuleImpl
{
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	TSharedPtr<FAssetTypeActions_MyAsset> MyAsset_AssetTypeActions;
};
IMPLEMENT_PRIMARY_GAME_MODULE( FBlog_MyAsset, Blog_MyAsset, "Blog_MyAsset" );

void FBlog_MyAsset::StartupModule()
{
	MyAsset_AssetTypeActions = MakeShareable(new FAssetTypeActions_MyAsset);
	FModuleManager::LoadModuleChecked<FAssetToolsModule>("AssetTools").Get().RegisterAssetTypeActions(MyAsset_AssetTypeActions.ToSharedRef());
}
void FBlog_MyAsset::ShutdownModule()
{
	if (MyAsset_AssetTypeActions.IsValid())
	{
		if (FModuleManager::Get().IsModuleLoaded("AssetTools"))
		{
			FModuleManager::GetModuleChecked<FAssetToolsModule>("AssetTools").Get().UnregisterAssetTypeActions(MyAsset_AssetTypeActions.ToSharedRef());
		}
		MyAsset_AssetTypeActions.Reset();
	}
}
